      subroutine initialPDF()
      integer flagalphas,mem,Nmem
      character name*40
      double precision alphasPDF,QMZ
      complex*16 alphas
      common/flagalphas/flagalphas
      common/name/name
      common/mem/mem

      if(flagpdf.eq.0) then

        call InitPDFsetByName(name)
        call numberPDF(Nmem)
        if(mem.gt.Nmem) then
          write(*,*)'input mem out of range!!!'
          stop
        endif

        call InitPDF(mem)
        flagpdf=1
      endif

      end



      SUBROUTINE partons(xmu,X,FX,NF,ISET,IH)
      implicit none
      integer Iprtn,ih,Irt,NF,ISET
      double precision fx(-NF:NF),x,xmu,sqxmu,fPDF(-6:6),temp
c---  ih1=+1 proton 
c---  ih1=-1 pbar 

C---set to zero if x out of range
      if (x .ge. 1d0) then
          do Iprtn=-5,5
             fx(Iprtn)=0d0
          enddo
          return
      endif
      sqxmu=sqrt(xmu)
      call evolvePDF(x,sqxmu,fPDF)

      if (ih.eq.1) then
        do Iprtn=-5,5
          fx(Iprtn)=fPDF(Iprtn)/x
        enddo
      elseif(ih.eq.-1) then
        do Iprtn=-5,5
          fx(+Iprtn)=fPDF(-Iprtn)/x
       enddo
      endif
! Change u and d quarks
      temp=fx(1)
      fx(1)=fx(2)
      fx(2)=temp
      temp=fx(-1)
      fx(-1)=fx(-2)
      fx(-2)=temp
      return
      end

      function alphas(nq2)
c.....N.B.:Here you have in output alpha_s/(4*Pi)!!!!!
      implicit none
      double precision alphasPDF,xmu,pi
      complex*16 alphas,nq2
      real*8 f(-6:6)
      data pi/3.14159265358979323846264338d0/

      xmu=dreal(cdsqrt(nq2))
      alphas=DCMPLX(alphasPDF(xmu),0d0)
      alphas=alphas/4d0/Pi

      return
      end


      subroutine lambda5qcd(lam,iset)
! dummy for LHAPFD
      implicit none
      integer iset
      real*8 lam
      return
      end
